# coding: utf-8

"""
    Swagger Blended Hub API Explorer

    A collection of Swagger documentation for the Blended Hub APIs.

    OpenAPI spec version: 1.0.0
    Contact: api@blended.co
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from pprint import pformat
from six import iteritems
import re


class ErrorResponse401(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, status_code=None, error=None, redirect_url=None):
        """
        ErrorResponse401 - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'status_code': 'int',
            'error': 'list[ShareApprovalListError]',
            'redirect_url': 'str'
        }

        self.attribute_map = {
            'status_code': 'status_code',
            'error': 'error',
            'redirect_url': 'redirect_url'
        }

        self._status_code = status_code
        self._error = error
        self._redirect_url = redirect_url

    @property
    def status_code(self):
        """
        Gets the status_code of this ErrorResponse401.
        Error custom status code.

        :return: The status_code of this ErrorResponse401.
        :rtype: int
        """
        return self._status_code

    @status_code.setter
    def status_code(self, status_code):
        """
        Sets the status_code of this ErrorResponse401.
        Error custom status code.

        :param status_code: The status_code of this ErrorResponse401.
        :type: int
        """

        self._status_code = status_code

    @property
    def error(self):
        """
        Gets the error of this ErrorResponse401.
        Validation error.

        :return: The error of this ErrorResponse401.
        :rtype: list[ShareApprovalListError]
        """
        return self._error

    @error.setter
    def error(self, error):
        """
        Sets the error of this ErrorResponse401.
        Validation error.

        :param error: The error of this ErrorResponse401.
        :type: list[ShareApprovalListError]
        """

        self._error = error

    @property
    def redirect_url(self):
        """
        Gets the redirect_url of this ErrorResponse401.
        url if redirection to website is needed at all.

        :return: The redirect_url of this ErrorResponse401.
        :rtype: str
        """
        return self._redirect_url

    @redirect_url.setter
    def redirect_url(self, redirect_url):
        """
        Sets the redirect_url of this ErrorResponse401.
        url if redirection to website is needed at all.

        :param redirect_url: The redirect_url of this ErrorResponse401.
        :type: str
        """

        self._redirect_url = redirect_url

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
